#include "descriptor/descriptor.h"

int main(void) {

  ITEM legno,glass,glass1,pink,battiscopa,legnotoro,white,white1,black,silver,black1,silver1;
  ITEM pavimento,soffitto,parete1,parete2,parete3,briscola,tavolo,sgabello,sgabello1,sgabello2,sgabello3;
  ITEM letto,base,tappeto,coperta,mazza,pallina,scudo,mazzo,carta,carta1,carta2,carta3,carta4,carta5,carta6,carta7,carta8,carta9,carta10,carta11,carta12,carta13,carta14,carta15,carta16,carta17,carta18,carta19,poster,rigolo,rigolo1,ramones,battifront,battileft,battiright,room;
  ITEM toro,torenko,bocca,muso,orecchiosx,orecchiodx,sopracigliasx,sopracigliadx,mandibolasx,mandiboladx,cornosx,cornodx,occhiosx,occhiodx,naricesx,naricedx,nardx,narsx;
  ITEM scene,taurus;

  set_background(0,0,0,TRUE);
  set_ambient_light(1,1,1,0.8);
  create_point_light(-14,90,5,1,1,1,1.0,25, "light1");
  create_point_light(-30,40,2,1,1,1,2.0,70, "light2");
  create_warn_light(-14.743,16.474,-0.869,-0.014,-0.998,-0.053,1.0,1.0,1.0,10,20,0,15.868, 3,0,0,0,0, "warn1");

  /*** ATTRIBUTE glass ***/
   glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,2.0);

  glass1 = create_attribute("glass");
  set_color(glass1,0.68,0.86,1,0.5,0.5);
  set_transparency(glass1,0.87,0.68,1,2.0);

  legno = create_attribute("legno");
  set_color(legno,225/255.0,122/255.0,68/255.0,0.6,0.85);

  battiscopa = create_attribute("battiscopa");
  set_color(battiscopa,70/255.0,40/255.0,14/255.0,0.2,0.6);

  pink = create_attribute("pink");
  set_color(pink,237/255.0,182/255.0,182/255.0,0.3,1.0);

  // ATTRIBUTE black /
  black = create_attribute("black");
  set_color(black,0,0,0,0.5,0.5);
  //set_transparency(black,0.87,0.68,1,1.0);

/*  trasparente = create_attribute("trasparente");
  set_color(trasparente,0.1,0.1,0.1,0.5,0.5);
  set_transparency(trasparente,0.87,0.68,1,1.0);
*/
  black1 = create_attribute("black1");
  set_color(black1,0,0,0,0.5,0.5);
  set_reflectivity(black1,0.1,1);
  set_transparency(black1,0.1,0.1,0.1,4.417);

  silver = create_attribute("silver");
  set_color(silver,0.482,0.482,0.450,0.5,0.5);
  set_reflectivity(silver,0.85,2);
  set_transparency(silver,0.87,0.68,1.5,14.0);

  silver1 = create_attribute("silver1");
  set_color(silver1,0.482,0.482,0.450,0.5,0.5);
   set_reflectivity(silver1,0.85,2);
  //set_transparency(silver1,0.87,0.68,1.5,14.0);

  legnotoro=create_attribute("legnotoro");
  set_color(legnotoro,0.403,0.211,0.117,0.5,0.5);
  set_reflectivity(legnotoro,0.09,1);
  //set_transparency(legnotoro,1,1,1,1.309);
  set_transparency(legnotoro,0.403,0.211,0.117,1.313);

  // ATTRIBUTE white 
  white = create_attribute("white");
  set_color(white,1,1,1,0.8,0.5);
  set_reflectivity(white,0.3,10);

  // ATTRIBUTE white1 
  white1 = create_attribute("white1");
  set_color(white1,1,1,1,1,1);

  pavimento = read_nurbs("pavimento.db");
  set_scale(pavimento,0.2,0.2,0.2);
  set_translate(pavimento,50,50,0);
  set_projection_texture(pavimento,black,"texture/pav.hr",2,TRUE,0.35,0.8);
  set_translate(pavimento,-50,-50,0);
  set_scale(pavimento,5.0,5.0,5.0);
  set_translate(pavimento,0,0,-25);

  soffitto = read_nurbs("soffitto.db");
  set_translate(soffitto,0,0,-25);

  parete1 = read_nurbs("left.db");
  set_translate(parete1,0,0,-25);
  battileft = read_nurbs("battileft.db");
  set_translate(battileft,-0.01,0,-25);

  parete2 = read_nurbs("right.db");
  set_translate(parete2,0,0,-25);
  battiright = read_nurbs("battiright.db");
  set_translate(battiright,0.01,0,-25);

  parete3 = read_nurbs("front.db");
  set_translate(parete3,0,0,-25);
  battifront = read_nurbs("battifront.db");
  set_translate(battifront,0,0,-25);

  set_attribute(soffitto, black);
  set_attribute(parete1, pink);
  set_attribute(parete2, pink);
  set_attribute(parete3, pink);
  set_attribute(battifront, battiscopa);
  set_attribute(battileft, battiscopa);
  set_attribute(battiright, battiscopa);

  room = create_list(pavimento,"room");
  room = insert_in_list(room,soffitto);
  room = insert_in_list(room,parete1);
  room = insert_in_list(room,parete2);
  room = insert_in_list(room,parete3);
  room = insert_in_list(room,battifront);
  room = insert_in_list(room,battileft);
  room = insert_in_list(room,battiright);

  letto = read_obj("bed.obj", "letto");	// applicare texture
  set_scale(letto,0.2,0.2,0.2);
  set_translate(letto,50,50,0);
  set_projection_texture(letto,black,"texture/bed.hr",TRUE,TRUE,0.3,0.8);
  set_translate(letto,-50,-50,0);
  set_scale(letto,5.0,5.0,5.0);
  set_translate(letto,-10,0.1,-24.98);

  coperta = read_nurbs("coperta.db");
  set_scale(coperta,0.2,0.2,0.2);
  set_translate(coperta,50,50,0);
  set_projection_texture(coperta,white1,"texture/trapunta.hr",2,TRUE,0.6,0.8);
  set_translate(coperta,-50,-50,0);
  set_scale(coperta,5.0,5.0,5.0);
  set_translate(coperta,-10,0.1,-24.98);

  tappeto = read_nurbs("carpet.db");		
  set_scale(tappeto,0.1,0.1,0.1);
  set_translate(tappeto,50,50,0);
  set_projection_texture(tappeto,white1,"texture/tappeto.hr",2,TRUE,0.6,0.8);
  set_translate(tappeto,-50,-50,0);
  set_scale(tappeto,10.0,10.0,10.0);
  set_translate(tappeto,-5,0,-24.99);


  tavolo = read_nurbs("tavolo.db");
  set_translate(tavolo,-4,1.5,-2.37);
  set_scale(tavolo,8,8,8);
  set_attribute(tavolo,glass);

  mazza = read_nurbs("mazza.db");
  set_translate(mazza,-1.38,0.58,4.76);
  set_x_rotate(mazza,180,1);
  set_scale(mazza,5,5,6);
  set_y_rotate(mazza,10,1);
  set_attribute(mazza,silver);

  pallina = read_nurbs("pallina.db");
  set_translate(pallina,-18,-1,-37.5);
  set_scale(pallina,0.7,0.7,0.7);
  set_attribute(pallina,silver);

  scudo = read_obj("scudo.obj","scudo");
  set_scale(scudo,0.1,0.1,0.1);
  set_translate(scudo,50,50,0);
  set_projection_texture(scudo,black1,"texture/wood.hr",2,TRUE,0.7,0.8);
  set_translate(scudo,-50,-50,0);
  set_scale(scudo,10.0,10.0,10.0);
  set_translate(scudo,-1.1,5,0);
  set_scale(scudo,3,3,3);
  set_z_rotate(scudo,90,1);

  carta = read_nurbs("carta.db");
  carta1 = create_copy(carta,"carta1");
  carta2 = create_copy(carta,"carta2");
  carta3 = create_copy(carta,"carta3");
  carta4 = create_copy(carta,"carta4");
  carta5 = create_copy(carta,"carta5");
  carta6 = create_copy(carta,"carta6");
  carta7 = create_copy(carta,"carta7");
  carta8 = create_copy(carta,"carta8");
  carta9 = create_copy(carta,"carta9");
  carta10 = create_copy(carta,"carta10");
  carta11 = create_copy(carta,"carta11");
  carta12 = create_copy(carta,"carta12");
  carta13 = create_copy(carta,"carta13");
  carta14 = create_copy(carta,"carta14");
  carta15 = create_copy(carta,"carta15");
  carta16 = create_copy(carta,"carta16");
  carta17 = create_copy(carta,"carta17");
  carta18 = create_copy(carta,"carta18");
  carta19 = create_copy(carta,"carta19");

  mazzo = create_list(carta,"mazzo");
  mazzo = insert_in_list(mazzo,carta1);
  mazzo = insert_in_list(mazzo,carta2);
  mazzo = insert_in_list(mazzo,carta3);
  mazzo = insert_in_list(mazzo,carta4);
  mazzo = insert_in_list(mazzo,carta5);
  mazzo = insert_in_list(mazzo,carta6);
  mazzo = insert_in_list(mazzo,carta7);
  mazzo = insert_in_list(mazzo,carta8);
  mazzo = insert_in_list(mazzo,carta9);
  mazzo = insert_in_list(mazzo,carta10);
  mazzo = insert_in_list(mazzo,carta11);
  mazzo = insert_in_list(mazzo,carta12);
  mazzo = insert_in_list(mazzo,carta13);
  mazzo = insert_in_list(mazzo,carta14);
  mazzo = insert_in_list(mazzo,carta15);
  mazzo = insert_in_list(mazzo,carta16);
  mazzo = insert_in_list(mazzo,carta17);
  mazzo = insert_in_list(mazzo,carta18);
  mazzo = insert_in_list(mazzo,carta19);
// MAZZO
  set_translate(carta,6.1,5,-19.542);
  set_scale(carta,1.4,1.4,1.4); 
  set_domain_texture(carta, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta6,6.2,5.0,-19.5415);
  set_scale(carta6,1.4,1.4,1.4); 
  set_domain_texture(carta6, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta7,6.6,5.0,-20.107);
  set_scale(carta7,1.4,1.4,1.4);
  set_y_rotate(carta7,1.5,1);
  set_domain_texture(carta7, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta8,6.65,5.0,-20.02);
  set_scale(carta8,1.4,1.4,1.4);
  set_y_rotate(carta8,1.3,1);
  set_domain_texture(carta8, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta9,6.75,5.0,-20.019);
  set_scale(carta9,1.4,1.4,1.4); 
  set_y_rotate(carta9,1.3,1);
  set_domain_texture(carta9, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta10,6.9,5.0,-20.018);
  set_scale(carta10,1.4,1.4,1.4); 
  set_y_rotate(carta10,1.3,1);
  set_domain_texture(carta10, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta11,7.0,5.0,-20.017);
  set_scale(carta11,1.4,1.4,1.4); 
  set_y_rotate(carta11,1.3,1);
  set_domain_texture(carta11, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);
  
  set_translate(carta12,7.2,5.0,-20.016);
  set_scale(carta12,1.4,1.4,1.4);
  set_y_rotate(carta12,1.3,1);
  set_domain_texture(carta12, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta13,7.3,5.0,-20.015);
  set_scale(carta13,1.4,1.4,1.4); 
  set_y_rotate(carta13,1.3,1);
  set_domain_texture(carta13, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta14,7.4,5.0,-20.014);
  set_scale(carta14,1.4,1.4,1.4);
  set_y_rotate(carta14,1.3,1);
  set_domain_texture(carta14, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);
  
  set_translate(carta15,7.6,5.0,-20.013);
  set_scale(carta15,1.4,1.4,1.4); 
  set_y_rotate(carta15,1.3,1);
  set_domain_texture(carta15, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta16,7.7,5.0,-20.012);
  set_scale(carta16,1.4,1.4,1.4); 
  set_y_rotate(carta16,1.3,1);
  set_domain_texture(carta16, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta17,7.9,5.0,-20.011);
  set_scale(carta17,1.4,1.4,1.4);
  set_y_rotate(carta17,1.3,1);
  set_domain_texture(carta17, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);;

  set_translate(carta18,8,5.0,-20.010);
  set_scale(carta18,1.4,1.4,1.4); 
  set_y_rotate(carta18,1.3,1);
  set_domain_texture(carta18, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta19,8.1,5.0,-20.009);
  set_scale(carta19,1.4,1.4,1.4);
  set_y_rotate(carta19,1.3,1);
  set_domain_texture(carta19, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

// separate

  set_translate(carta1,8.0,5.2,-19.5);
  set_scale(carta1,1.4,1.4,1.4);
  set_x_rotate(carta1,-0.2,1);
  set_z_rotate(carta1,0.2,1);
  set_domain_texture(carta1, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta2,8.8,5.1,-19.52);
  set_scale(carta2,1.4,1.4,1.4); 
  set_domain_texture(carta2, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta3,8.5,5.0,-19.53);
  set_scale(carta3,1.4,1.4,1.4); 
  set_domain_texture(carta3, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta4,10,5,-25.2);
  set_scale(carta4,1.4,1.4,1.4); 
  set_domain_texture(carta4, white, "texture/10.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  set_translate(carta5,9.2,5.3,-25.2);
  set_scale(carta5,1.4,1.4,1.4);
  set_domain_texture(carta5, white, "texture/carte.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  sgabello = read_nurbs("sgabello.db");
  sgabello1 = create_copy(sgabello,"sgabello1");
  sgabello2 = create_copy(sgabello,"sgabello2");
  sgabello3 = create_copy(sgabello,"sgabello3");

  set_translate(sgabello,0,5,-25.2);
  set_attribute(sgabello,white);

  set_translate(sgabello1,-5,11.5,-25.2);
  set_attribute(sgabello1,white);
  
  set_translate(sgabello2,0,16.5,-25.2);
  set_attribute(sgabello2,white);

  set_translate(sgabello3,10,5,-25.2);
  set_attribute(sgabello3,white);

  poster = read_nurbs("poster.db");		//texture
  rigolo = read_nurbs("rigolo.db");
  rigolo1 = read_nurbs("rigolo1.db");

  set_domain_texture(poster, white1, "texture/kill.hr", 1, 0, 1, 0, FALSE, 0.8, 0.5);

  ramones = create_list(poster,"ramones");
  ramones = insert_in_list(ramones,rigolo);
  ramones = insert_in_list(ramones,rigolo1);

  set_translate(ramones,1.5,-0.6,-0.5);
  set_scale(ramones,6,6,6);
  set_attribute(rigolo,black);
  set_attribute(rigolo1,black);
					// TAURUS
					// crea lista
  toro = read_nurbs("taurus.dbe");				//forse da mod
  bocca = read_nurbs("bocca.db");
  muso = read_nurbs("muso.dbe");
  naricesx = read_nurbs("naricesx.dbe");
  naricedx = read_nurbs("naricedx.dbe");
  orecchiosx = read_nurbs("orecchiosx.dbe");
  orecchiodx = read_nurbs("orecchiodx.dbe");
  sopracigliasx = read_nurbs("sopracigliasx.dbe");
  sopracigliadx = read_nurbs("sopracigliadx.dbe");
  mandibolasx = read_nurbs("mandibolasx.db");
  mandiboladx = read_nurbs("mandiboladx.db");
  occhiosx = read_nurbs("occhiosx.db");
  cornosx = read_nurbs("cornosx.db");
  occhiodx = read_nurbs("occhiodx.db");
  cornodx = read_nurbs("cornodx.db");
  narsx = read_nurbs("narsx.db");
  nardx = read_nurbs("nardx.db");

  taurus = create_list(toro,"taurus");
  taurus = insert_in_list(taurus,muso);
  taurus = insert_in_list(taurus,orecchiosx);
  taurus = insert_in_list(taurus,orecchiodx);
  taurus = insert_in_list(taurus,sopracigliasx);
  taurus = insert_in_list(taurus,sopracigliadx);
  taurus = insert_in_list(taurus,naricesx);
  taurus = insert_in_list(taurus,narsx);
  taurus = insert_in_list(taurus,naricedx);
  taurus = insert_in_list(taurus,nardx);
  taurus = insert_in_list(taurus,mandibolasx);
  taurus = insert_in_list(taurus,mandiboladx);
  taurus = insert_in_list(taurus,occhiosx);
  taurus = insert_in_list(taurus,cornosx);
  taurus = insert_in_list(taurus,occhiodx);
  taurus = insert_in_list(taurus,cornodx);
  taurus = insert_in_list(taurus,bocca);

  set_translate(taurus,-15,-0.3,-24.5);
  set_attribute(taurus,legnotoro);

  scene = create_list(room, "scene");
  scene = insert_in_list(scene,letto);
  scene = insert_in_list(scene,coperta);
  scene = insert_in_list(scene,tappeto);
  scene = insert_in_list(scene,tavolo);
  scene = insert_in_list(scene,mazza);
  scene = insert_in_list(scene,pallina);
  scene = insert_in_list(scene,scudo);
  scene = insert_in_list(scene,mazzo);
  scene = insert_in_list(scene,sgabello);
  scene = insert_in_list(scene,sgabello1);
  scene = insert_in_list(scene,sgabello2);
  scene = insert_in_list(scene,sgabello3);
  scene = insert_in_list(scene,ramones);
  scene = insert_in_list(scene,taurus);

  save_scene("toro.md","scene_toro",scene);
  return(0);
}
